; Frosted/theme.jl

(let*
  (
    (font (get-font "-*-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1"))
    (font-colors (list "blue" "black"))
    
    (title-width
       (lambda (w)
	 (let
	     ((w-width (car (window-dimensions w))))
             (max 0 (+ 5 (min (- w-width 105)
	     (text-width (window-name w))))))))
				    
    (update-title-width
       (lambda (w)
          (if (eq (window-get w 'current-frame-style) 'Frosted)
             (rebuild-frame w))))
            
	(title-images (list (set-image-border
	                    (make-image "title-bar-inactive.png") 1 1 0 0)
                            (set-image-border
			    (make-image "title-bar-active.png")1 1 0 0)))

     	(iconify-images (list (make-image "iconify-normal.png")
			      nil nil
                              (make-image "iconify-clicked.png")))       
	
	(close-images (list (make-image "close-normal.png")
			    nil nil
                            (make-image "close-clicked.png")))

        (menu-images (make-image "menu-normal.png"))
                             
        (win-icon     (lambda (w)
	              (let ((icon (window-icon-image w)))
			          (if icon icon menu-images))))

     	(title-left (make-image "title_left.png"))
	
	
	(title-right (set-image-border 
	             (make-image "title_right.png")22 10 0 0))
	(top-right-side (set-image-border
	                     (make-image "top-right-side.png")22 10 0 0))
	(border-top (make-image "border_top.png"))
	(border-top-1 (make-image "border_top_1.png"))
     	(border-bottom (make-image "border_bottom.png"))
     	(border-right (make-image "border_right.png"))
     	(border-left (make-image "border_left.png"))

        (corner-tl-2 (make-image "corner_top_left_2.png"))
	(corner-tr-2 (make-image "corner_top_right_2.png"))
	(corner-bl-2 (make-image "corner_bottom_left_2.png"))
	(corner-br-2 (make-image "corner_bottom_right_2.png"))
				

     	(frame `(

               ((background . ,title-images)
		 (top-edge . -22)
		 (left-edge . 16)
		 (right-edge . 16)
		 (class . top-left-corner))
               
	       ((background . ,title-images)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
		 (x-justify . left)
                 (y-justify . center)
		 (top-edge . -22)
		 (left-edge . 35)
		 (right-edge . 16)
		 (class . title))

               ((background . ,title-left)
	         (top-edge . -22)
		 (left-edge . -4)
		 (class . top-left-corner))
	       
		((background . ,title-right)
		 (top-edge . -22)
		 (right-edge . -22)
		 (class . title))
		 
		((background . ,top-right-side)
		 (top-edge . 0)
		 (right-edge . -22)
		 (class . title))
		
	     	((background . ,border-top-1)
      		 (top-edge . -22)
      		 (right-edge . 20)
      		 (left-edge . 20) 
      		 (class . top-border))

		((background . ,iconify-images)
      		 (top-edge . -22)
		 (right-edge . 0) 
		 (class . iconify-button))

                ((background . ,win-icon)
		 (x-justify . center)
		 (y-justify . center)
		 (top-edge . -20)
		 (left-edge . 4)
		 (width . 19)
		 (height . 19)
		 (class . menu-button))

    		((background . ,close-images)
      		 (top-edge . 2)
      		 (right-edge . -20)
      		 (class . close-button))

     		((background . ,border-left)
      		 (top-edge . 0)
      		 (bottom-edge . 0)
      		 (left-edge . -4) 
      		 (class . left-border))

     		((background . ,border-right)
      		 (top-edge . 37)
      		 (bottom-edge . 0)
      		 (right-edge . -4)
      		 (class . right-border))

     		((background . ,border-bottom)
      		 (bottom-edge . -4)
      		 (right-edge . 0)  
      		 (left-edge . 0)   
      		 (class . bottom-border))

     		((background . ,corner-bl-2)
      		 (bottom-edge . -4)
      		 (left-edge . -4)  
      		 (class . bottom-left-corner))

     		((background . ,corner-br-2)
      		 (bottom-edge . -4)
      		 (right-edge . -4) 
      		 (class . bottom-right-corner))
	))

	(shaped-frame `(
      	         ((background . ,title-images)
		 (top-edge . -22)
		 (left-edge . 16)
		 (right-edge . 16)
		 (class . top-left-corner))
			 		 		
     		((background . ,title-images)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
		 (x-justify . left)
                 (y-justify . center)
		 (top-edge . -22)
		 (left-edge . 35)
		 (right-edge . 16)
		 (class . title))

                ((background . ,title-left)
		 (top-edge . -22)
		 (left-edge . -4)
		 (class . top-left-corner))
		
                ((background . ,title-right)
		 (top-edge . -22)
		 (right-edge . -22)
		 (class . title))
		 
		((background . ,top-right-side)
		 (top-edge . 0)
		 (right-edge . -22)
		 (class . title))
		
	     	((background . ,border-top-1)
      		 (top-edge . -22)
      		 (right-edge . 10)
      		 (left-edge . 10) 
      		 (class . top-border))

     		((background . ,iconify-images)
      		 (top-edge . -22)
		 (right-edge . 0) 
		 (class . iconify-button))

                ((background . ,win-icon)
		 (x-justify . center)
		 (y-justify . center)
		 (top-edge . -20)
		 (left-edge . 4)
		 (width . 19)
		 (height . 19)
		 (class . menu-button))

    		((background . ,close-images)
      		 (top-edge . 2)
      		 (right-edge . -20)
      		 (class . close-button))
  
	))

	(transient-frame `(

     		((background . ,border-left)
      		 (top-edge . 0)
      		 (bottom-edge . 0)
      		 (left-edge . -4) 
      		 (class . left-border))

     		((background . ,border-right)
      		 (top-edge . 0)
      		 (bottom-edge . 0)
      		 (right-edge . -4)
      		 (class . right-border))

	     	((background . ,border-top)
      		 (top-edge . -4)
      		 (right-edge . 0)
      		 (left-edge . 0) 
      		 (class . title))

     		((background . ,border-bottom)
      		 (bottom-edge . -4)
      		 (right-edge . 0)  
      		 (left-edge . 0)   
      		 (class . bottom-border))

     		((background . ,corner-tl-2)
      		 (top-edge . -4)
      		 (left-edge . -4)
      		 (class . top-left-corner))

     		((background . ,corner-tr-2)
      		 (top-edge . -4)
      		 (right-edge . -4)
      		 (class . top-right-corner))

     		((background . ,corner-bl-2)
      		 (bottom-edge . -4)
      		 (left-edge . -4)  
      		 (class . bottom-left-corner))

     		((background . ,corner-br-2)
      		 (bottom-edge . -4)
      		 (right-edge . -4) 
      		 (class . bottom-right-corner))
	))
	
	(shaped-transient-frame `(
                
		 ((background . ,title-images)
		 (top-edge . -22)
		 (left-edge . 16)
		 (right-edge . 16)
		 (class . top-left-corner))
 		
     		((background . ,title-images)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
		 (x-justify . left)
                 (y-justify . center)
		 (top-edge . -22)
		 (left-edge . 41)
		 (right-edge . 16)
		 (class . title))

                ((background . ,title-left)
		 (top-edge . -22)
		 (left-edge . 2)
		 (class . top-left-corner))
		
		((background . ,title-right)
		 (top-edge . -22)
		 (right-edge . 0)
		 (class . top-right-corner))		 
	        
	     	((background . ,border-top-1)
      		 (top-edge . -22)
      		 (right-edge . 16)
      		 (left-edge . 16) 
      		 (class . top-border))
     		 
		((background . ,win-icon)
		 (x-justify . center)
		 (y-justify . center)
		 (top-edge . -20)
		 (left-edge . 10)
		 (width . 19)
		 (height . 19)
		 (class . menu-button))

     		((background . ,close-images)
      		 (top-edge . -22)
      		 (right-edge . 16)
      		 (class . close-button))

	))
	
  )
  (add-frame-style 'Frosted
       (lambda (w type)
	  (case type
	    ((default) frame)
	    ((transient) transient-frame)
	    ((shaped) shaped-frame)
            ((shaped-transient) shaped-transient-frame))))
                
   (call-after-property-changed
        'WM_NAME (lambda ()
	    (rebuild-frames-with-style 'Frosted))))
